Bug 1731634

Summary: impressive depends on Python 2
Product: [Fedora] Fedora Reporter: Lumír Balhar <lbalhar>
Component: impressiveAssignee: Michael J Gruber <mjg>
Status: CLOSED RAWHIDE QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: 31CC: mjg, pviktori
Target Milestone: ---Keywords: Triaged
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard:
Fixed In Version: Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2019-08-18 15:04:04 UTC Type: Bug
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Bug Depends On:    
Bug Blocks: 1698500    

Description Lumír Balhar 2019-07-20 06:53:22 UTC
Python 2.7 will reach end-of-life in January 2020, over 9 years after it was released. This falls within the Fedora 31 lifetime.
Packages that depend on Python 2 are being switched to Python 3 or removed from Fedora: https://fedoraproject.org/wiki/Changes/F31_Mass_Python_2_Package_Removal#Information_on_Remaining_Packages
Python 2 will be retired in Fedora 32: https://fedoraproject.org/wiki/Changes/RetirePython2

To help planning, we'd like to know the plans for impressive's future. Specifically:

- What are the upstream/community plans/timelines regarding Python 3?

- What is the guidance for porting to Python 3? (Assuming that there is someone who generally knows how to port to Python 3, but doesn't know anything about the particular package, what are the next steps to take?)


This bug is filed semi-automatically, and might not have all the context specific to impressive.
If you need anything from us, or something is unclear, please mention it here.

Thank you.

Comment 1 Lumír Balhar 2019-07-29 04:50:29 UTC
Please answer the above questions. If you don't the package can be orphaned: https://fedoraproject.org/wiki/Changes/F31_Mass_Python_2_Package_Removal#Information_on_Remaining_Packages

If you need any information or help, please let us know.

Comment 2 Michael J Gruber 2019-07-29 11:51:23 UTC
First of all, threatening with "forced orphaning" mere 9 day after the request is completely inappropriate. You get paid to work on free software, I do it in my spare time.

Second, upstream is doing this in their spare time, as well.

Third, the first of the 3 questions from the wiki is missing in this bug.

Reason
======

impressive is written in Python 2

Plans/timeline
==============

Upstream opposes Python 3 for fundamental reasons, they (or rather he:) prefer Tauthon. He would port to Python 3 only when forced, but understands that impressive will get kicked out of Fedora in a few months if not. So he will possibly give in.

At least that's the timeline that I understood based on our release schedule. Has this been rescheduled ahead?


Guidance
========

Upstream's plan is to "do it right" in order to catch problems before rather than at run-time (where they often appear for quick-and dirty ports). That is, he wants to use the forced port for restructuring the code base:
- build a coverage testsuite
- clean split into modules
- check every single use of strings, division, filter, map, zip; rewrite all print


So how much time will you give him for porting 7000 lines of code?

Comment 3 Petr Viktorin 2019-07-29 13:29:27 UTC
> You get paid to work on free software, I do it in my spare time.

While some people can use paid time for Python 2 maintenance, that will end. Unfortunately, I don't yet know anyone who would like to do it in their spare time -- I myself would rather hack on py3.
But we'd like to do better than just retire python2 and let everyone else deal with it.


> the first of the 3 questions from the wiki is missing in this bug.

Yup, the wiki says for "some or all" of the information. Here the reason seemed obvious.


> Upstream opposes Python 3 for fundamental reasons, they (or rather he:) prefer Tauthon.

Are there any plans to put Tauthon into Fedora? That would also be an option.


> Has this been rescheduled ahead?

No, so far it hasn't. But we're gathering information in these bugs.


> So how much time will you give him for porting 7000 lines of code?

I don't know how much time is needed; it depends on the code.
The Python 2 EOL date has been known for a few years already; is there anything special in impressive that needs more time?

Comment 4 Ben Cotton 2019-08-13 17:04:30 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 31 development cycle.
Changing version to '31'.

Comment 5 Ben Cotton 2019-08-13 18:53:11 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 31 development cycle.
Changing version to 31.

Comment 6 Lumír Balhar 2019-08-14 08:34:46 UTC
The current plan is to remove packages with dependency on Python 2 from Fedora 32 in the middle of November 2019. If you want to keep your package in Fedora after that date and you cannot port it to Python 3 yet, you need to request a FESCo exception for the package and all its Python 2 dependencies (even transitive) [1]. If you don't want to maintain it anymore, and nothing in Fedora uses it, you can retire it or just remove the Python 2 part from it (subpackage, module, bindings, etc.).

If you're considering filing the exception request, let us know. We can help (for example, we can help find all the dependencies).

[1] https://fedoraproject.org/wiki/Changes/RetirePython2#FESCo_exceptions

Comment 7 Michael J Gruber 2019-08-18 15:04:04 UTC
impressive 0.12.0-10 is a py3 port of the current svn version, which in turn is 0.12.0 plus a few bugfixes.

This port is my work (https://github.com/mjg/Impressive/tree/py3k) but coordinated with upstream who will use this port (plus modifications) as the base for a new release. I have upstream's OK to package this port until a proper py3-ready release comes out.

The port itself transforms the code into py2+py3-capable code, which is why I left the original shebangs in place (in the patch) and fix them in prep just like before.

I'll probably push this to F31, too, to give this wider exposure and reduce the "py2-burden" on F31.

Comment 8 Petr Viktorin 2019-08-19 07:32:22 UTC
That sounds great, thank you!